-- File: TwitchEmotes.lua
-- Name: Twitch Emotes
-- Author: tannerng
-- Description: Adds Twitch chat emotes into WoW chat
-- Version: 1.0.1

local EMOTES = {}

EMOTES["3Head"] = "\124TInterface/AddOns/TwitchEmotes/emotes/3Head:26:26:0:0:128:64:0:32:0:32\124t"
EMOTES["4Head"] = "\124TInterface/AddOns/TwitchEmotes/emotes/4Head:24:16:0:0:128:64:0:20:0:30\124t"
EMOTES["4House"] = "\124TInterface/AddOns/TwitchEmotes/emotes/4House:24:24:0:0:128:64:0:32:0:32\124t"
EMOTES["5Head"] = "\124TInterface/AddOns/TwitchEmotes/emotes/5Head:26:21:0:0:128:64:0:26:0:32\124t"
EMOTES[":("] = "\124TInterface/AddOns/TwitchEmotes/emotes/Frown:15:20:0:0:128:64:0:24:0:18\124t"
EMOTES[":)"] = "\124TInterface/AddOns/TwitchEmotes/emotes/Smile:15:20:0:0:128:64:0:24:0:18\124t"
EMOTES[":D"] = "\124TInterface/AddOns/TwitchEmotes/emotes/SmileD:15:20:0:0:128:64:0:24:0:18\124t"
EMOTES[":p"] = "\124TInterface/AddOns/TwitchEmotes/emotes/SmileP:15:20:0:0:128:64:0:24:0:18\124t"
EMOTES[";)"] = "\124TInterface/AddOns/TwitchEmotes/emotes/SmileWink:15:20:0:0:128:64:0:24:0:18\124t"
EMOTES["<3"] = "\124TInterface/AddOns/TwitchEmotes/emotes/3Heart:15:20:0:0:128:64:0:24:0:18\124t"
EMOTES["AMAZINGA"] = "\124TInterface/AddOns/TwitchEmotes/emotes/AMAZINGA:22:28:0:0:128:64:0:32:0:25\124t"
EMOTES["AngelThump"] = "\124TInterface/AddOns/TwitchEmotes/emotes/AngelThump:24:72:0:0:128:64:0:84:0:28\124t"
EMOTES["AYAYA"] = "\124TInterface/AddOns/TwitchEmotes/emotes/AYAYA:27:28:0:0:128:64:0:32:0:31\124t"
EMOTES["BabyRage"] = "\124TInterface/AddOns/TwitchEmotes/emotes/BabyRage:25:25:0:0:128:64:0:28:0:28\124t"
EMOTES["BibleThump"] = "\124TInterface/AddOns/TwitchEmotes/emotes/BibleThump:25:30:0:0:128:64:0:36:0:30\124t"
EMOTES["BlessRNG"] = "\124TInterface/AddOns/TwitchEmotes/emotes/BlessRNG:24:24:0:0:128:64:0:28:0:28\124t"
EMOTES["Clap"] = "\124TInterface/AddOns/TwitchEmotes/emotes/Clap:18:13:0:-2:128:64:0:16:0:21\124t"
EMOTES["cmonBruh"] = "\124TInterface/AddOns/TwitchEmotes/emotes/cmonBruh:24:24:0:0:128:64:0:28:0:28\124t"
EMOTES["D:"] = "\124TInterface/AddOns/TwitchEmotes/emotes/DColon:25:25:0:0:128:64:0:28:0:28\124t"
EMOTES["DansGame"] = "\124TInterface/AddOns/TwitchEmotes/emotes/DansGame:26:20:0:0:128:64:0:25:0:32\124t"
EMOTES["DICKS"] = "\124TInterface/AddOns/TwitchEmotes/emotes/DICKS:16:80:0:0:128:64:0:100:0:20\124t"
EMOTES["EZ"] = "\124TInterface/AddOns/TwitchEmotes/emotes/EZ:22:24:0:0:128:64:0:28:0:26\124t"
EMOTES["FailFish"] = "\124TInterface/AddOns/TwitchEmotes/emotes/FailFish:25:18:0:0:128:64:0:22:0:30\124t"
EMOTES["FeelsBadMan"] = "\124TInterface/AddOns/TwitchEmotes/emotes/FeelsBadMan:25:26:0:0:128:64:0:30:0:29\124t"
EMOTES["FeelsGoodMan"] = "\124TInterface/AddOns/TwitchEmotes/emotes/FeelsGoodMan:26:26:0:0:128:64:0:30:0:30\124t"
EMOTES["FeelsOkayMan"] = "\124TInterface/AddOns/TwitchEmotes/emotes/FeelsOkayMan:24:25:0:0:128:64:0:28:0:27\124t"
EMOTES["FeelsSpecialMan"] = "\124TInterface/AddOns/TwitchEmotes/emotes/FeelsSpecialMan:23:26:0:0:128:64:0:28:0:25\124t"
EMOTES["FeelsStrongMan"] = "\124TInterface/AddOns/TwitchEmotes/emotes/FeelsStrongMan:25:26:0:0:128:64:0:32:0:31\124t"
EMOTES["FeelsWeirdMan"] = "\124TInterface/AddOns/TwitchEmotes/emotes/FeelsWeirdMan:25:26:0:0:128:64:0:28:0:27\124t"
EMOTES["FeelsWeirdManW"] = "\124TInterface/AddOns/TwitchEmotes/emotes/FeelsWeirdManW:26:30:0:0:128:64:0:32:0:28\124t"
EMOTES["gachiBASS"] = "\124TInterface/AddOns/TwitchEmotes/emotes/gachiBASS:21:18:0:0:128:64:0:28:0:32\124t"
EMOTES["gachiHYPER"] = "\124TInterface/AddOns/TwitchEmotes/emotes/gachiHYPER:21:18:0:0:128:64:0:24:0:28\124t"
EMOTES["GivePLZ"] = "\124TInterface/AddOns/TwitchEmotes/emotes/GivePLZ:26:26:0:0:128:64:0:28:0:28\124t"
EMOTES["HandsUp"] = "\124TInterface/AddOns/TwitchEmotes/emotes/HandsUp:18:34:0:0:128:64:0:38:0:20\124t"
EMOTES["HeyGuys"] = "\124TInterface/AddOns/TwitchEmotes/emotes/HeyGuys:24:24:0:0:128:64:0:28:0:28\124t"
EMOTES["HYPERBRUH"] = "\124TInterface/AddOns/TwitchEmotes/emotes/HYPERBRUH:24:24:0:0:128:64:0:32:0:32\124t"
EMOTES["HYPERLUL"] = "\124TInterface/AddOns/TwitchEmotes/emotes/HYPERLUL:24:24:0:0:128:64:0:32:0:32\124t"
EMOTES["HYPERS"] = "\124TInterface/AddOns/TwitchEmotes/emotes/HYPERS:24:24:0:0:128:64:0:28:0:28\124t"
EMOTES["Jebaited"] = "\124TInterface/AddOns/TwitchEmotes/emotes/Jebaited:23:23:0:0:128:64:0:28:0:28\124t"
EMOTES["Kapp"] = "\124TInterface/AddOns/TwitchEmotes/emotes/Kapp:18:7:0:0:128:64:0:8:0:21\124t"
EMOTES["Kappa"] = "\124TInterface/AddOns/TwitchEmotes/emotes/Kappa:24:20:0:0:128:64:0:25:0:28\124t"
EMOTES["KKomrade"] = "\124TInterface/AddOns/TwitchEmotes/emotes/KKomrade:24:24:0:0:128:64:0:28:0:28\124t"
EMOTES["KKona"] = "\124TInterface/AddOns/TwitchEmotes/emotes/KKona:26:18:0:0:128:64:0:22:0:32\124t"
EMOTES["Kreygasm"] = "\124TInterface/AddOns/TwitchEmotes/emotes/Kreygasm:24:17:0:0:128:64:0:19:0:27\124t"
EMOTES["LUL"] = "\124TInterface/AddOns/TwitchEmotes/emotes/LUL:24:24:0:0:128:64:0:28:0:28\124t"
EMOTES["LULW"] = "\124TInterface/AddOns/TwitchEmotes/emotes/LULW:28:25:0:0:128:64:0:28:0:32\124t"
EMOTES["monkaEyes"] = "\124TInterface/AddOns/TwitchEmotes/emotes/monkaEyes:16:60:0:0:128:64:0:75:0:20\124t"
EMOTES["monkaGun"] = "\124TInterface/AddOns/TwitchEmotes/emotes/monkaGun:26:26:0:0:128:64:0:28:0:28\124t"
EMOTES["monkaHmm"] = "\124TInterface/AddOns/TwitchEmotes/emotes/monkaHmm:26:26:0:0:128:64:0:28:0:28\124t"
EMOTES["monkaOMEGA"] = "\124TInterface/AddOns/TwitchEmotes/emotes/monkaOMEGA:26:26:0:0:128:64:0:32:0:32\124t"
EMOTES["monkaS"] = "\124TInterface/AddOns/TwitchEmotes/emotes/monkaS:26:26:0:0:128:64:0:28:0:28\124t"
EMOTES["monkaW"] = "\124TInterface/AddOns/TwitchEmotes/emotes/monkaW:28:28:0:0:128:64:0:32:0:32\124t"
EMOTES["NotLikeThis"] = "\124TInterface/AddOns/TwitchEmotes/emotes/NotLikeThis:24:24:0:0:128:64:0:28:0:28\124t"
EMOTES["OhMyDog"] = "\124TInterface/AddOns/TwitchEmotes/emotes/OhMyDog:24:24:0:0:128:64:0:28:0:28\124t"
EMOTES["OkayChamp"] = "\124TInterface/AddOns/TwitchEmotes/emotes/OkayChamp:28:28:0:0:128:64:0:28:0:28\124t"
EMOTES["OMEGALUL"] = "\124TInterface/AddOns/TwitchEmotes/emotes/OMEGALUL:26:25:0:0:128:64:0:32:0:31\124t"
EMOTES["PagChomp"] = "\124TInterface/AddOns/TwitchEmotes/emotes/PagChomp:27:27:0:0:128:64:0:32:0:32\124t"
EMOTES["peepoBlanket"] = "\124TInterface/AddOns/TwitchEmotes/emotes/peepoBlanket:27:26:0:0:128:64:0:31:0:32\124t"
EMOTES["peepoClown"] = "\124TInterface/AddOns/TwitchEmotes/emotes/peepoClown:26:26:0:4:128:64:0:28:0:28\124t"
EMOTES["peepoGlad"] = "\124TInterface/AddOns/TwitchEmotes/emotes/peepoGlad:18:26:0:0:128:64:0:32:0:22\124t"
EMOTES["peepoHappy"] = "\124TInterface/AddOns/TwitchEmotes/emotes/peepoHappy:18:26:0:0:128:64:0:28:0:20\124t"
EMOTES["peepoHug"] = "\124TInterface/AddOns/TwitchEmotes/emotes/peepoHug:18:24:0:0:128:64:0:28:0:21\124t"
EMOTES["peepoSad"] = "\124TInterface/AddOns/TwitchEmotes/emotes/peepoSad:18:26:0:0:128:64:0:28:0:19\124t"
EMOTES["peepoWTF"] = "\124TInterface/AddOns/TwitchEmotes/emotes/peepoWTF:17:25:0:0:128:64:0:28:0:19\124t"
EMOTES["Pepega"] = "\124TInterface/AddOns/TwitchEmotes/emotes/Pepega:22:28:0:0:128:64:0:32:0:25\124t"
EMOTES["PepeHands"] = "\124TInterface/AddOns/TwitchEmotes/emotes/PepeHands:26:26:0:0:128:64:0:32:0:32\124t"
EMOTES["PepeLaugh"] = "\124TInterface/AddOns/TwitchEmotes/emotes/PepeLaugh:27:27:0:0:128:64:0:32:0:32\124t"
EMOTES["PepoThink"] = "\124TInterface/AddOns/TwitchEmotes/emotes/PepoThink:27:28:0:0:128:64:0:32:0:31\124t"
EMOTES["PJSalt"] = "\124TInterface/AddOns/TwitchEmotes/emotes/PJSalt:25:30:0:0:128:64:0:36:0:30\124t"
EMOTES["Pog"] = "\124TInterface/AddOns/TwitchEmotes/emotes/Pog:25:25:0:0:128:64:0:28:0:28\124t"
EMOTES["PogChamp"] = "\124TInterface/AddOns/TwitchEmotes/emotes/PogChamp:26:20:0:0:128:64:0:23:0:30\124t"
EMOTES["Pogey"] = "\124TInterface/AddOns/TwitchEmotes/emotes/Pogey:26:26:0:0:128:64:0:32:0:32\124t"
EMOTES["POGGERS"] = "\124TInterface/AddOns/TwitchEmotes/emotes/POGGERS:27:27:0:0:128:64:0:32:0:32\124t"
EMOTES["PogU"] = "\124TInterface/AddOns/TwitchEmotes/emotes/PogU:27:27:0:0:128:64:0:32:0:32\124t"
EMOTES["POOGERS"] = "\124TInterface/AddOns/TwitchEmotes/emotes/POOGERS:27:27:0:0:128:64:0:32:0:32\124t"
EMOTES["ResidentSleeper"] = "\124TInterface/AddOns/TwitchEmotes/emotes/ResidentSleeper:24:24:0:0:128:64:0:28:0:28\124t"
EMOTES["SeemsGood"] = "\124TInterface/AddOns/TwitchEmotes/emotes/SeemsGood:25:25:0:0:128:64:0:28:0:28\124t"
EMOTES["SMOrc"] = "\124TInterface/AddOns/TwitchEmotes/emotes/SMOrc:26:26:0:0:128:64:0:32:0:32\124t"
EMOTES["SwiftRage"] = "\124TInterface/AddOns/TwitchEmotes/emotes/SwiftRage:24:18:0:0:128:64:0:21:0:28\124t"
EMOTES["ThisIsFine"] = "\124TInterface/AddOns/TwitchEmotes/emotes/ThisIsFine:28:25:0:0:128:64:0:28:0:31\124t"
EMOTES["TriHard"] = "\124TInterface/AddOns/TwitchEmotes/emotes/TriHard:26:26:0:0:128:64:0:28:0:28\124t"
EMOTES["VoteNay"] = "\124TInterface/AddOns/TwitchEmotes/emotes/VoteNay:26:26:0:0:128:64:0:28:0:28\124t"
EMOTES["VoteYea"] = "\124TInterface/AddOns/TwitchEmotes/emotes/VoteYea:26:26:0:0:128:64:0:28:0:28\124t"
EMOTES["WeirdChamp"] = "\124TInterface/AddOns/TwitchEmotes/emotes/WeirdChamp:28:28:0:0:128:64:0:32:0:32\124t"
EMOTES["WideHard"] = "\124TInterface/AddOns/TwitchEmotes/emotes/WideHard:16:40:0:0:128:64:0:50:0:20\124t"
EMOTES["WideHarder"] = "\124TInterface/AddOns/TwitchEmotes/emotes/WideHarder:16:64:0:0:128:64:0:80:0:20\124t"
EMOTES["widepeepoHappy"] = "\124TInterface/AddOns/TwitchEmotes/emotes/widepeepoHappy:16:64:0:0:128:64:0:80:0:19\124t"
EMOTES["widepeepoSad"] = "\124TInterface/AddOns/TwitchEmotes/emotes/widepeepoSad:16:64:0:0:128:64:0:80:0:20\124t"
EMOTES["WutFace"] = "\124TInterface/AddOns/TwitchEmotes/emotes/WutFace:25:25:0:0:128:64:0:28:0:28\124t"

-- added in 1.0.1
EMOTES["ANELE"] = "\124TInterface/AddOns/TwitchEmotes/emotes/ANELE:24:24:0:0:128:64:0:28:0:28\124t"
EMOTES["HotPokket"] = "\124TInterface/AddOns/TwitchEmotes/emotes/HotPokket:25:23:0:0:128:64:0:28:0:30\124t"
EMOTES["peepoWeird"] = "\124TInterface/AddOns/TwitchEmotes/emotes/peepoWeird:18:26:0:0:128:64:0:28:0:20\124t"
EMOTES["B)"] = "\124TInterface/AddOns/TwitchEmotes/emotes/SmileGlasses:15:20:0:0:128:64:0:24:0:18\124t"
EMOTES[":/"] = "\124TInterface/AddOns/TwitchEmotes/emotes/SmileMeh:15:20:0:0:128:64:0:24:0:18\124t"
EMOTES[":o"] = "\124TInterface/AddOns/TwitchEmotes/emotes/SmileO:15:20:0:0:128:64:0:24:0:18\124t"
EMOTES["R)"] = "\124TInterface/AddOns/TwitchEmotes/emotes/SmileR:15:20:0:0:128:64:0:24:0:18\124t"
EMOTES[";p"] = "\124TInterface/AddOns/TwitchEmotes/emotes/SmileWinkP:15:20:0:0:128:64:0:24:0:18\124t"
EMOTES[":z"] = "\124TInterface/AddOns/TwitchEmotes/emotes/SmileZ:15:20:0:0:128:64:0:24:0:18\124t"
EMOTES["TheIlluminati"] = "\124TInterface/AddOns/TwitchEmotes/emotes/TheIlluminati:24:24:0:0:128:64:0:28:0:28\124t"
EMOTES["Wowee"] = "\124TInterface/AddOns/TwitchEmotes/emotes/Wowee:24:24:0:0:128:64:0:28:0:28\124t"

function replaceEmotes(message, t, smiley)
    local tp = t
    if smiley then
        tp = string.sub(t, 1, 1).."%"..string.sub(t, 2, 2)
    end
    
    message = string.gsub(message, "^"..tp.."$", EMOTES[t]) --solo emote
    message = string.gsub(message, "^"..tp.."(%s)", EMOTES[t].."%1") --emote at beginning with trailing space
    message = string.gsub(message, "(%s)"..tp.."(%s)", "%1"..EMOTES[t].."%2") --emote with leading and trailing space
    message = string.gsub(message, "(%s)"..tp.."$", "%1"..EMOTES[t]) --emote at end with leading space
    
    return message
end

function onChatMessage(self, event, message, ...)
    for t in string.gmatch(message, "%S+") do -- tokenize string
        if EMOTES[t] then -- if token is an emote
            -- handle stupid robot face emotes
            if string.sub(t, 2, 2) == ")" or string.sub(t, 2, 2) == "(" then 
                message = replaceEmotes(message, t, true)
            else
                message = replaceEmotes(message, t, false)
            end
        end
    end
    
    return false, message, ...
end


local CHAT_TYPES = {
    "AFK",
    "BATTLEGROUND_LEADER",
    "BATTLEGROUND",
    "BN_WHISPER",
    "CHANNEL",
    "COMMUNITIES_CHANNEL",
    "DND",
    "EMOTE",
    "GUILD",
    "OFFICER",
    "PARTY_LEADER",
    "PARTY",
    "RAID_LEADER",
    "RAID_WARNING",
    "RAID",
    "SAY",
    "WHISPER",
    "WHISPER_INFORM",
    "YELL",
    "SYSTEM"
}

for _, type in pairs(CHAT_TYPES) do
    ChatFrame_AddMessageEventFilter("CHAT_MSG_" .. type, onChatMessage)
end
